-- fichier p_rationnels_g.ads
-- D. Feneuille 98 (d'aprs un exo GNAT) et T.Avignon
-- pour le TP 11; le body est  raliser compltement

generic
     type T_Entier is range <>; -- paramtre gnrique
package P_Rationnels_G is

   subtype T_Entier_Pos is T_Entier range 1..T_Entier'Last;

   type T_Rationnel is  private; -- Le T.A.D. en question
   
   -- valeur constante rationnelle nulle
   Nulle : constant T_Rationnel;
   
   -- constructeur

   function "/" (X : T_Entier; Y : T_Entier) return T_Rationnel;

   Zero_Denominateur: exception;

   -- slecteurs (accs aux composants) :

   function Numer (R : T_Rationnel) return T_Entier;
   function Denom (R : T_Rationnel) return T_Entier_Pos;

   -- oprateurs de comparaison

   function "<" (R1 : T_Rationnel; R2 : T_Rationnel) return Boolean;
   function "<="(R1 : T_Rationnel; R2 : T_Rationnel) return Boolean;
   function ">" (R1 : T_Rationnel; R2 : T_Rationnel) return Boolean;
   function ">="(R1 : T_Rationnel; R2 : T_Rationnel) return Boolean;
   
   -- oprateurs unaires

   function "+"(R: T_Rationnel)   return T_Rationnel;
   function "-"(R: T_Rationnel)   return T_Rationnel;
   function "abs"(R: T_Rationnel) return T_Rationnel;

   -- oprateurs binaires

   function "+"(R1 : T_Rationnel; R2 : T_Rationnel) return T_Rationnel;
   function "-"(R1 : T_Rationnel; R2 : T_Rationnel) return T_Rationnel;
   function "*"(R1 : T_Rationnel; R2 : T_Rationnel) return T_Rationnel;
   function "/"(R1 : T_Rationnel; R2 : T_Rationnel) return T_Rationnel;
   function "*"(R1 : T_Rationnel; R2 : T_Entier)  return T_Rationnel;

private

   type T_Rationnel is record
      Numerateur  : T_Entier  := 0;
      Denominateur: T_Entier_Pos := 1;
   end record;

   Nulle : constant T_Rationnel := (0,1);
   
end P_Rationnels_G;
