-- fichier dry_poly.ads
-- D.F. pour TP 17 testabilit
--
-- Elements de corrig du paquetage drivers de test de P_POLY_V1_G.V3
-- d'aprs les indications de P.M. (voir le document tudiant)
--
-- la partie ci-dessous ne prend en compte que l'aspect excution des tests
-- c'est--dire l'criture des drivers et leur lancement
--
-- la partie "plan de test" et la partie "rapport de test"
-- qui (respectivement) prcde et suit l'excution ne sont pas ici!
--

with P_Poly_V1_G.V3;     -- pas de use stupide !!!
with P_Rationnels_G.Io;  -- pas de use stupide !!!

generic
   type T_Entier is range <>;
   Max : Positive;
   with package P_Rationnels is new P_Rationnels_G(T_Entier);
   with package P_Rationnels_Io is new  P_Rationnels.Io(<>);
   with package P_Poly_V1 is new P_Poly_V1_G (Max,P_Rationnels,
      P_Rationnels_Io);
   with package P_Poly_V3 is new P_Poly_V1.V3(<>);
package Dri_Poly is

   procedure Tst_Get_Put;    -- partie donne en corrig en TD
   procedure Tst_Set_Put;    -- partie donne en corrig en TP

   procedure Tst_Get_Coef;   --  tester
   procedure Tst_Get_Degre;  --  tester
   procedure Tst_Valeur;     --  tester
   procedure Tst_Derivee;    --  tester (4 contrats minimum)

   -- etc....  faire en plus !

   -- remarques :
   --
   -- on a vu que Get et Put taient "solidaires" (TD testabilite).
   -- il en est de meme pour Set et Put (vu au mme TD!).
   --
   -- On redirigera les sorties dans un fichier Fic_Out au lancement
   --
   -- Pratiquement il faut crire un programme de test par "test".
   --
   -- exemple de procdure de lancement du test Un_Test:
   -- with Dri_Poly;
   -- procedure Ts_Un_Test is
   -- attention il faut instancier Dri_Poly
   -- begin
   --  Dri_Poly_Vrai.Tst_Un_Test;
   -- end Ts_Un_Test;
   --
   -- exemple de lancement
   -- ./Ts_Un_Test  >Fic.Out
   --
   -- Pour les tests ( finir) il faut initialiser un (des) polynome(s)!

end Dri_Poly;
